module Ubc.Parse.Syntax.Enumeration 
( Enumeration(..)
, parse
)
where

import Text.Parsec (ParsecT, many, (<?>))

import qualified Ubc.Parse.Syntax.Language as UbcLanguage

type EnumerationMember = String
data Enumeration = Enumeration 
                        { name :: String
                        , members :: [EnumerationMember]
                        }
                        deriving (Show)

parse :: Monad m => ParsecT String u m Enumeration
parse = do
        UbcLanguage.reserved "enum"
        identifier <- UbcLanguage.identifier <?> "enum identifier"
        values <- UbcLanguage.braces $ many UbcLanguage.identifier

        return $! Enumeration identifier values

